use strict;
use warnings;
use Module::Build;

my $builder = Module::Build->new(
    module_name         => 'POWER::Event::IO',
    license             => 'perl',
    dist_author         => 'Alex Efros <powerman@asdfgroup.com>',
    dist_version_from   => 'lib/POWER/Event/IO.pm',
    requires => {
        # to test
        'Test::More'            => 0,
        'Test::Exception'       => 0,
        'Data::Alias'           => 0.08,
        'POWER::Utils::Resource'=> 0,
        'POWER::Utils::IO'      => 0,
        # to run
        'version'               => 0,
        'Perl6::Export::Attrs'  => 0,
        'Crypt::RC4'            => 0,
        'POWER::Epoll'          => 'v2.0.0',
        'POWER::Event::Timer'   => 0,
        'POWER::Utils'          => 0,
        'Crypt::MatrixSSL'      => '1.83',
    },
    add_to_cleanup      => [ 'POWER-Event-IO-*' ],
);

$builder->create_build_script();

$builder->notes(google => $builder->y_n('Allow google test?','y'));
$builder->notes(proxy  => $builder->y_n('Allow https proxy test?','n'));
if ($builder->notes('proxy')) {
    $builder->notes(proxy_host =>
        $builder->prompt('https proxy host:', '192.168.2.1'));
    $builder->notes(proxy_port =>
        $builder->prompt('https proxy port:', '3128'));
}
$builder->notes(netfs =>
    $builder->prompt('Path to network fs mounted rw (if any):',''));

