# TODO OPTIMIZATION
# -    in_bytes / out_bytes. 
#       -    /,
#   ..   defined  exists  .  
#          read/write   .
#   NOTE     UDP    in_bytes  
#           length(), .. recv   $n. :-(
#
# -      UDP_CONNECTED::_real_read, 
#      .., , DNS  512   .
#
# -   'hint',    
#   state=>$CONNECTING     _real_write()  new().
#
# -  write()    $buf  {out_buf}   
#    -     .    UDP.
#   NOTE         -  
#           POWER::Event::IO::UDP_CONNECTED::write(), 
#            write, _write  _real_write.
#               $buf  
#             syswrite()    
#           {out_buf},      
#            .
#               - 10-15%      
#                     (   write()).
#              -     .
#           : .      . :-(
#
# -    sysread ( POWER::Event::IO)   - 
#    "short read", EOF  .    
#     ,      
#    EOF.
#
# -    weaken      @Timer_*
#        I/O,     
#   weaken-  .
#          weaken   
#        .
#
# -        dualvar(). 
#    ,    dualvar()  .


#       I/O:
# - new()  ,       
#        ţ .
# -          
#        (   , 
#   ,   weaken).
# - close()   -weaken      
#   .
# -    ݣ new() ,   
#   ( callback ӣ-  ţ ).
# -      ,     close() 
#       -weaken     ( 
#     weaken-    POWER::Event::IO).
# -      :  I/O 
#         ;    
#       I/O: $io->{plugin}{PLUGIN_NAME_HERE};
#      -weaken   ,    
#   close()    .


#     :
# -      $n   - ,
#     ,    $n .
# -  - ,       ,
#          I/O,  ģ 
#    .
# -   $n   ,   ,
#        "timed out",   
#      $m     
#         (   ).
# 
#  :
# -     1/10  (  
#    ""    ).
# - ģ     @Timer ( ).
# -   $n-    $self:
#       unshift @{ $Timer[$n*10] }, $self;
#       weaken $Timer[$n*10][0];
# -    ,    , 10  
#    :
#       for my $obj (@{ shift @Timer || [] }) {
#           next if !$obj;      # skip destroyed weaken references
#           ...                 # process $obj
#       }
# -        
#   - @Timer.
# 
#      10   
#  (  callback    ,
#          ),
#      ޣ   
#     (      ),
# /     1/10 ,   .. "" -
#   .   callback   
# ,   ""   1/10 .  
# callbacks   ,     
#       .


# Nonblock() vs fcntl() vs ioctl():
#  , ioctl  ""     
#    POSIX     ioctl   
#      (fcntl, ).
#    IMHO      ioctl -
#         
# . :)    ioctl     ,  fcntl   -
#  ioctl! :-)
#   ioctl-.  perldoc : require "ioctl.ph".
#    . :)   : require "asm/ioctls.ph".
# , -, ioctl-    man ioctl_list,  
#         .


package POWER::Event::IO;

use version; $VERSION = qv('0.3.2');    # update POD & Changes & README

use warnings;
use strict;
use Carp;

use Scalar::Util qw( weaken dualvar );
use Socket;

use Perl6::Export::Attrs;

use base qw( POWER::Event::IO::plugin );
use POWER::Event::IO::share;
use POWER::Event::IO::STREAM;
use POWER::Event::IO::LISTEN;
use POWER::Event::IO::UDP;
use POWER::Event::IO::UDP_CONNECTED;
use POWER::Event::IO::SSL::CLIENT;
use POWER::Event::IO::SSL::SERVER;
use POWER::Event::IO::PROXY::HTTPS;
use POWER::Event::IO::CRYPT::RC4;
use POWER::Event::IO::DNS;
use POWER::Epoll 2.0.0;


my @IO_for;                     # map fileno(fh) => POWER::Event::IO object


$SIG{PIPE}  = 'IGNORE' if !defined $SIG{PIPE};


$DNS->_init();


$Class{'POWER::Event::IO'} = {
    event       => $ERR|$RESOLVED|$CONNECTED|$IN|$OUT|$EOF|$SENT,
    style       => $STREAM_IO,
    socktype    => $SOCK_STREAM,
    sockproto   => $PROTO_TCP,
};


sub IMPORT {
    my $pkg = caller(0);
    no strict 'refs';
    *{$pkg.'::'.$_} = \${$_} for qw(
        ERR RESOLVED CONNECTED ACCEPTED IN OUT EOF SENT
        EINBUFLIMIT
        );
}

#   IP-:
# -  ip
# -  _real_config()   _state  $CONNECTING  $HANDLING
#      fh  connect  bind+listen
sub RESOLVED {
    my ($self, $host, $ip, $error) = (@_);
    if (defined $ip) {
        $self->{ip} = $ip;
        if ($self->{wait_for} & $RESOLVED) {
            $self->{_events}       |= $RESOLVED;
            $Ready{ $self->{fd} }   = $self;
        }
        $self->_real_config($self);
    }
    else {
        $self->{_events}       |= $ERR;
        $self->{_err}           = $error;
        $Ready{ $self->{fd} }   = $self;
    }
}

#   I/O:
# -  
# -     (   fh
#    host+port,  fh    
#    host):
#       fh, wait_for, cb
# -    :
#       method, in_buf_limit, out_buf, out_pos
# -  
# -    (-weaken)   @IO_for
# -      epoll  
#    wait_for  _state
# -   {out_buf}        _state $HANDLING,
#      _write()
sub new {
    my ($class, $opt_ref) = @_;
    croak 'Usage: POWER::Event::IO->new({ OPTIONS })'
        if @_ != 2 || ref($opt_ref) ne 'HASH';
    croak '{cb} required'
        if !defined $opt_ref->{cb};
    # die 'Internal error' if !$Class{$class};
    my $buf  = $Class{$class}{style} == $PACKET_IO ? undef : q{};
    my $self = bless {
        #  ,     :
        fh          => undef,
        host        => undef,
        port        => undef,
        plugin      => {},
        wait_for    => 0,
        cb          => $opt_ref->{cb},
        #       :
        method      => 'IO',
        in_buf_limit=> undef,
        out_buf     => $buf,                # modified on: $OUT
        out_pos     => undef,               # modified on: $OUT
        #  new():
        events      => 0,                   # modified on: any waited event
        err         => undef,               # modified on: $ERR
        in_buf      => $buf,                # modified on: $IN|$ACCEPTED
        in_bytes    => 0,                   # modified on: $IN
        in_paddr    => undef,               # modified on: $IN|$ACCEPTED
        out_bytes   => 0,                   # modified on: $OUT
        out_paddr   => undef,               # destination for $UDP write
        ip          => undef,               # modified on: $RESOLVED
        is_eof      => undef,               # modified on: $EOF
        fd          => undef,               # fileno(fh), key for %Ready
        _Event      => $Class{$class}{event},
        _Style      => $Class{$class}{style},
        _state      => 0,
        _epoll      => 0,                   # waiting epoll events
        _events     => 0,                   # events for next callback call
        _err        => undef,               # error  for next callback call
        _cb         => [],                  # struct cached for POWER::Event
        _tick_write => 0,                   # $Tick value at last writing
        _timer_write=> 0,                   # TRUE if $self in @Timer_write
        _write_needed=>0,                   # TRUE if must _write() when _state
                                            #   become $HANDLING
        # Plugin support:
        _has_out    => 0,
        __wait_SENT => 0,
        __next      => undef,
        }, $class;
    #        as is.
    for my $k ( grep {m/\A(?:method|in_buf_limit|out_buf|out_pos|[A-Z].*)\z/xms}
                keys %$opt_ref ) {
        $self->{$k} = $opt_ref->{$k};
    }
    #      wait_for.
    $self->_set_wait_for($opt_ref->{wait_for}) if $opt_ref->{wait_for};
    # OPTIMIZATION    [ $cb, $method, $self ] 
    #                  io_wait()  POWER::Event 
    #                    callback.
    $self->{_cb} = [ $self->{cb}, $self->{method}, $self ];
    weaken $self->{_cb}[2];
    #  .
    my $last = $self;
    if (exists $opt_ref->{plugin}) {
        croak '{plugin} must be ARRAYREF' if ref $opt_ref->{plugin} ne 'ARRAY';
        my @plugin = @{ $opt_ref->{plugin} };
        while (@plugin) {
            my ($name, $plugin) = splice @plugin, 0, 2;
            $last = $last->{__next} = $self->{plugin}{$name} = $plugin;
            weaken $self->{plugin}{$name};
            $plugin->ATTACH($self);
        }
    }
    $last->{__next} = $POWER::Event::IO::STREAM::Stream;

    ###########################
    #  fh  _state ###
    ###########################

    #    fh,   _state  $HANDLING.
    if (defined $opt_ref->{fh}) {
        $self->{fh}     = $opt_ref->{fh};
        $self->{_state} = $HANDLING;
    }
    #    _state   fh   host.
    else {
        #       ( 
        # -   fd)  croak  $io  fh
        #    .
        socket($self->{fh}, $AF_INET, $Class{$class}{socktype},
            $Class{$class}{sockproto})              or croak "socket: $!";
        ioctl($self->{fh}, $FIONBIO, $IOCTL_TRUE)   or croak "ioctl: $!";
        croak '{fh} or {host}+{port} required'
            if !defined $opt_ref->{host} || !defined $opt_ref->{port};
        $self->{host}   = $opt_ref->{host};
        $self->{port}   = $opt_ref->{port};
        $self->{_state} = $RESOLVING;
        $DNS->_resolve($self->{host}, $self);
    }

    ############################################
    ###    epoll  @IO_for ###
    ############################################

    $self->{fd} = fileno($self->{fh});
    croak '{fh} is not open FILEHANDLE'     if !defined $self->{fd};

    #  $fd  epoll;   {out_buf}   _write().
    # 
    #   fd  epoll   EPOLLIN   
    #      ($ACCEPTED  $IN  $EOF);
    # EPOLLOUT    _state != $HANDLING    
    #    $CONNECTED (..    
    # connect), ..  EPOLLOUT      
    # connect ۣ    _state  $HANDLING.
    # 
    # OPTIMIZATION   _state != $HANDLING,    out_buf, 
    #                 _write()    {_write_needed},
    #                _write()    _state  
    #                $HANDLING.
    #                    _write()
    #                new().
    $self->{_epoll} |= $EPOLLIN
        if $self->{wait_for} & ($ACCEPTED|$IN|$EOF);
    $self->{_epoll} |= $EPOLLOUT
        if $self->{_state} != $HANDLING && $self->{_Event} & $CONNECTED;
    epoll_add($EPFD, $self->{fd}, $self->{_epoll})
        if $self->{_state} != $RESOLVING;
    if (defined $opt_ref->{out_buf}) {
        if ($self->{_state} == $HANDLING) {
            $self->_write();
        }
        else {
            $self->{_write_needed} = 1;
        }
    }

    #     @IO_for.
    croak 'you must do $io->close() first'
        if $IO_for[ $self->{fd} ];
    $IO_for[ $self->{fd} ] = $self;
   
    return $self;
}

#sub _attach {
#    my ($self, $plugin, $before) = @_;
#    $before ||= $POWER::Event::IO::STREAM::Stream;
#    my $current = $self;
#    while ($current->{__next} != $before) {
#        $current = $current->{__next};
#        croak "Can't attach $plugin : $before not found \n"
#            if !$current->{__next};
#    }
#    $plugin->{__next}   = $current->{__next};
#    $current->{__next}  = $plugin;
#    $plugin->ATTACH($self);
#    return $self;
#}

#    .
sub _detach {
    my ($self, $plugin) = @_;
    my $current = $self;
    while ($current->{__next} != $plugin) {
        $current = $current->{__next};
        croak "Can't detach $plugin : not found\n" if !$current->{__next};
    }
    $plugin->DETACH($self);
    $current->{__next} = $current->{__next}->{__next};
    return $self;
}

#  wait_for     epoll.
sub wait_for {
    my ($self, $wait_for) = @_;
    croak 'Usage: $io->wait_for( FLAGS )' if @_ != 2;
    $self->_set_wait_for($wait_for);
    my $epoll
        = ($self->{_epoll} & ~ $EPOLLIN)
        | (($self->{wait_for} & ($ACCEPTED|$IN|$EOF)) ? $EPOLLIN : 0)
        ;
    if ($self->{_epoll} != $epoll) {
        epoll_mod($EPFD, $self->{fd}, $epoll);
        $self->{_epoll} = $epoll;
    }
    return;
}

#  wait_for    .
sub _set_wait_for {
    my ($self, $wait_for) = @_;
#{ no warnings 'numeric';
    croak 'wrong event mask'
        if !defined($wait_for)
        || $wait_for ne 0+$wait_for
        || $wait_for & ~$self->{_Event};
#}
    croak 'you must set {in_buf_limit} if you wanna $EOF without $IN'
        if $wait_for & $EOF
        && !($wait_for & $IN)
        && !defined $self->{in_buf_limit};
    $self->{wait_for} = $wait_for;
    return;
}

#     out_buf,   .
#   out_buf,   .
sub write {
    my ($self, $buf) = @_;
    croak 'Usage: $io->write( [$buf] )' if !(1 <= @_ && @_ <= 2);
    if (defined $buf) {
        if ($self->{_Style} == $PACKET_IO) {
            croak q{previous packet isn't sent yet} if defined $self->{out_buf};
            $self->{out_buf} = $buf;
        }
        else {
            $self->{out_buf} .= $buf;
        }
    }
    if ($self->{_state} != $HANDLING) {
        $self->{_write_needed} = 1;
    }
    elsif (!($self->{_epoll} & $EPOLLOUT)) {
        $self->_write();
    }
    return;
}

#   I/O.
sub close {
    my ($self) = @_;
    delete $Ready{ $self->{fd} };
    $IO_for[ $self->{fd} ] = undef;
    close $self->{fh};
    return;
}

#     epoll.
#   callback   .
sub io_wait :Export(:event) {
    croak  q{usage: io_wait TIMEOUT} if @_ != 1;
    my ($timeout) = @_;
#{ no warnings 'numeric';
    croak qq{wrong TIMEOUT $timeout}
        if defined $timeout && ($timeout ne 0+$timeout || $timeout < 0);
#}
    my @read    = @READ;
    my @write   = @WRITE;
    @READ       = ();
    @WRITE      = ();
    for (@read) {
        next if !$_;
#warn("($_->{fd}) \@READ ->_read\n"),
        $_->_read();
    }
    for (@write) {
        next if !$_;
        # TODO        EPOLLOUT.  
        #         -  ţ ,   
        #       .       
        #        ţ  -    . :(
        if ($_->{_epoll} & $EPOLLOUT) {
            unshift @WRITE, $_;
            weaken $WRITE[0];
        } else {
#warn("($_->{fd}) \@WRITE ->_write\n"),
            $_->_write();
        }
    }
    $timeout = 0 if keys %Ready;
    my ($status, $events) = epoll_wait($EPFD, $timeout);
    return undef if $status==-1;    # EINTR only!
    for (@$events) {
        my ($fd, $events) = @$_;
        my $io = $IO_for[$fd];
        croak qq{Internal error: no I/O object for events=$events on fd=$fd}
            if !$io;
#warn ">>> ".($DNS->{fd}==$fd ? 'DNS' : "FD=$fd")." events=".join(q{,},($events & $EPOLLIN  ? 'IN' : ()),($events & $EPOLLOUT ? 'OUT' : ()),($events & $EPOLLHUP ? 'HUP' : ()),($events & $EPOLLERR ? 'ERR' : ()))."\n";
        if ($io->{_state} != $HANDLING && $events & $EPOLLOUT) {
            # _state    $RESOLVING ..  EPOLLOUT
            #   _state=$RESOLVING   
            #  $CONNECTED,    EPOLLOUT  
            #   connect()   ... .
            $io->{_state} = $HANDLING;
            #    $CONNECTED    
            if ($io->{wait_for} & $CONNECTED) {
                $io->{_events} |= $CONNECTED;
                $Ready{ $io->{fd} } = $io;
            }
#warn ">>>   HANDLING!\n";
        }
#warn(">>>   _real_read\n"),
#warn("($io->{fd}) EPOLLIN ->_read\n"),
        $io->_read()  if $events & ($EPOLLIN|$EPOLLHUP|$EPOLLERR);
#warn(">>>   _write\n"),
#warn("($io->{fd}) EPOLLOUT ->_write\n"),
        $io->_write() if $events & $EPOLLOUT;
    }
    my @events = values %Ready;
    %Ready = ();
    return $status, map {
            $_->{events}    = $_->{_events};
            $_->{err}       = $_->{_err};
            $_->{_events}   = 0;
            $_->{_err}      = undef;
            $_->{_cb};
        } @events;
}

sub _read {
    my ($self) = @_;
    if ($self->{_events} & $ERR) {
        unshift @READ, $self;
        weaken $READ[0];
    }
    else {
        $self->_real_read($self);
        $self->{_events} &= ($self->{wait_for}|$ERR);
        $Ready{ $self->{fd} } = $self if $self->{_events};
    }
    return;
}

sub _write {
    my ($self) = @_;
    if ($self->{_events} & $ERR) {
        unshift @WRITE, $self;
        weaken $WRITE[0];
    }
    else {
        $self->{_has_out} = 0;
        $self->_real_write($self);
        $self->{_events} &= ($self->{wait_for}|$ERR);
        $Ready{ $self->{fd} } = $self if $self->{_events};
    }
    return;
}

1; # Magic true value required at end of module
__END__

=head1 NAME

POWER::Event::IO - Async, event-based I/O object


=head1 VERSION

This document describes POWER::Event::IO version 0.3.2


=head1 SYNOPSIS

    use POWER::Event::IO;

    ###
    ### NOTE: To have POWER::Event::IO objects working you
    ###       must execute loop() after configuring initial
    ###       POWER::Event::IO objects! See example below:
    ###
    # need this module to get loop() function:
    use POWER::Event;
    # create some client & server objects:
    POWER::Event::IO->new({ ... });
    POWER::Event::IO::UDP_CONNECTED->new({ ... });
    POWER::Event::IO::LISTEN->new({ ... });
    # fall info event loop to have I/O working:
    loop();
    
    ###
    ### TCP client: fetch http://google.com/
    ###
    POWER::Event::IO->new({
        host        => 'google.com',
        port        => 80,
        wait_for    => $EOF,
        cb          => \&google,
        out_buf     => "GET / HTTP/1.0\nHost: google.com\n\n",
        in_buf_limit=> 102400,
    });
    sub google {
        my ($io) = @_;
        if ($io->{events} & $EOF) {
            print "Got reply from google:\n\n", $io->{in_buf};
            exit;
        }
        die $io->{err}              if $io->{events} & $ERR;
    }

    ###
    ### TCP client: fetch https://google.com/ using https proxy
    ###
    POWER::Event::IO->new({
        host        => 'google.com',
        port        => 443,
        wait_for    => $EOF,
        cb          => \&google,
        out_buf     => "GET / HTTP/1.0\nHost: google.com\n\n",
        in_buf_limit=> 102400,
        plugin      => [
            ssl         => POWER::Event::IO::SSL::CLIENT->new({
                trusted_CA  => '/etc/ssl/certs/ca-certificates.crt',
            }),
            proxy       => POWER::Event::IO::PROXY::HTTPS->new({
                host        => '127.0.0.1',
                port        => 3128,
            }),
        ],
    });
    # ... use sub google from previous example

    ###
    ### TCP server: listen on port; setup server object
    ###
    POWER::Event::IO::LISTEN->new({
        host        => '127.0.0.1',
        port        => 1234,
        wait_for    => $ACCEPTED,
        cb          => \&listener,
    });
    sub listener {
        my ($io) = @_;
        if ($io->{events} & $ERR) {
            die "error on listening socket: $io->{err}\n";
        }
        # If we reach this point then $ACCEPTED event happens
        # because it's only event in {wait_for} and we already
        # checked for $ERR (which always can happens).
        my ($port, $iaddr) = sockaddr_in($io->{in_paddr});
        my $ip = inet_ntoa($iaddr);
        printf "Connection from [%s:%s]\n", $ip, $port;
        # Create new POWER::Event::IO object for handling I/O
        # with just connected client:
        POWER::Event::IO->new({
            fh          => delete $io->{in_buf},
            wait_for    => $IN|$OUT,
            cb          => \&server,
        });
    }
    sub server {
        my ($io) = @_;
        # ...
    }

    ###
    ### UNIX client & 'echo' server
    ###
    use POWER::Utils::IO;   # unix_client(), unix_server()
    POWER::Event::IO::LISTEN->new({
        fh          => unix_server('/tmp/mysock'),
        wait_for    => $ACCEPTED,
        cb          => \&listener,
    });
    POWER::Event::IO->new({
        fh          => unix_client('/tmp/mysock'),
        wait_for    => $EOF|$SENT,
        cb          => \&client,
        out_buf     => 'Hello!',
        in_buf_limit=> 1024,
    });
    sub listener {
        my ($io) = @_;
        die $io->{err}              if $io->{events} & $ERR;
        POWER::Event::IO->new({
            fh          => delete $io->{in_buf},
            wait_for    => $EOF|$SENT,
            cb          => \&server,
            in_buf_limit=> 1024,
        });
    }
    sub server {
        my ($io) = @_;
        $io->write($io->{in_buf})   if $io->{events} & $EOF;
        $io->close()                if $io->{events} & $SENT;
        die $io->{err}              if $io->{events} & $ERR;
    }
    sub client {
        my ($io) = @_;
        shutdown $io->{fh}, 1       if $io->{events} & $SENT;
        if ($io->{events} & $EOF) {
            print "Got reply from server: $io->{in_buf}\n";
            exit;
        }
        die $io->{err}              if $io->{events} & $ERR;
    }


=head1 DESCRIPTION

       I/O.
 ң     :  -,
,   ,   
    .

   ,      
 I/O,         ,
 I/O.

     callback -  
   I/O.

 أ        
   I/O   ,   
       --.
      POWER::Event::IO
  ,  - POWER::Event::IO    
   fh,  -   
POWER::Event::IO     
/       .


=head1 USAGE

 ,  POWER::Event::IO   fh,   
"".     POWER::Event::IO->new().
 ""   ,    
     new()  ,  
  POWER::Event::IO->new().  new(),  ,  
  ,       -
     :    fh 
        new()
callback       new() .
 ݣ new()      ,
        callback    .

=over 8

       POWER::Event, - 
POWER::Event::IO   ,   -  
loop()  POWER::Event,  -     callback.

=back

  fh  POWER::Event::IO    fh (, 
    )     write(),
   fh  close(). ݣ   wait_for()  
      callback.

          (,
,  ,      
  I/O). ,   fh     
{in_buf},           ( 
  callback   fh   $IN  $EOF)    
 ӣ,   - , , , etc.

=over

    ,     
 :   Σ     -  
      ,     
-      undef     ,  
   RO (read only) -    . 
     .

=back


=head1 LOW-LEVEL I/O

  fh  POWER::Event::IO      ӣ  
(bind/fcntl/sysread/syswrite/etc...).   fh 
POWER::Event::IO,    ң   POWER::Event::IO - 
  sysread/recv/accept, syswrite/send  close -    
    (       
, . shutdown, setsockopt, bind, fcntl, ioctl, stat, etc.).

=over

     ,    
POWER::Event::IO     .     
  . :-)   POWER::Event::IO - 
/     ,  -  
   /.      
   -      EAGAIN   
     /...   
,     .

  -   fh    
close()  POWER::Event::IO,     close().

=back

 /   fh POWER::Event::IO   
 ,   IP-,  
      connect/bind/listen,  - 
   .      POWER::Event::IO,
       ,    .

       
,     :

 eof()          -  is_eof
 fileno()       -  fd
 getpeername()  -  paddr ( accept()- )


=head3 BLOCKING WARNING

  ,     callback   -
   !

 open
          
    FS    FIFO.
 opendir
          
    FS.
 flock


=head1 CLASSES

 POWER::Event::IO   :

=over

=item POWER::Event::IO->new()

, TCP  UNIX(STREAM) .

=item POWER::Event::IO::UDP_CONNECTED->new()

UDP-    connect().

=item POWER::Event::IO::UDP->new()

UDP-     connect().

=item POWER::Event::IO::LISTEN->new()

 TCP  UNIX(STREAM) .

=back

  -      ;   
     -:

                                            
  POWER::Event::IO                     sysread     syswrite
  POWER::Event::IO::UDP_CONNECTED       sysread     syswrite
  POWER::Event::IO::UDP                 recv        send
  POWER::Event::IO::LISTEN              accept      -

   write()      
  {out_buf},     
  {in_buf},        
 {out_pos} -       {out_buf},
  {out_pos}   -  .

         
    .     
write()      ,  ɣ  
     . (   
     Σ undef .. /ɣ 
   -   .)

  -    (c $RESOLVED, $ACCEPTED 
$CONNECTED     ):

                                                     
                                            C                    
                                    R   A   O                    
                                    E   C   N                    
                                    S   C   N                    
                                    O   E   E                    
                                    L   P   C               S    
                                    V   T   T       E   O   E   E
                                    E   E   E   I   O   U   N   R
                                    D   D   D   N   F   T   T   R
  --------------------------------v------------------------------
  POWER::Event::IO                | X       X   X   X   X   X   X
  POWER::Event::IO::UDP_CONNECTED | X           X       X       X
  POWER::Event::IO::UDP           |             X       X       X
  POWER::Event::IO::LISTEN        | X   X                       X


=head1 PLUGINS

 /        
.     ,   
   I/O.

    ,   
 .       
I/O    ,        
 -weaken    ,     
    close()   I/O.   
           
      I/O    
        I/O:

 POWER::Event::IO->new({
     ... other params ...
     #     I/O  :  ssl, 
     # https proxy -   ssl ۣ  ,   !
     plugin      => [
         #      SSL-;
         #    "ssl".
         ssl         => POWER::Event::IO::SSL::CLIENT->new({
             trusted_CA  => '/etc/ssl/certs/ca-certificates.crt',
         }),
         #      HTTPS-;
         #    "myproxy".
         myproxy     => POWER::Event::IO::PROXY::HTTPS->new({
             host        => '127.0.0.1',
             port        => 3128,
         }),
     ],
 });
 sub callback {
     my ($io) = @_;
     if ($io->{events} & $CONNECTED) {
         #         I/O:
         printf "Connected to HTTPS server through HTTPS proxy %s:%d\n",
             $io->{plugin}{myproxy}{host}, $io->{plugin}{myproxy}{port};
         printf "HTTPS server certificate checked succesfully using "
             . "root CA certificates list in '%s'\n",
             $io->{plugin}{ssl}{trusted_CA};
     }
 }

      .  :

 STREAM PLUGINS (for POWER::Event::IO objects):
    POWER::Event::IO::SSL::CLIENT
    POWER::Event::IO::SSL::SERVER
    POWER::Event::IO::PROXY::HTTPS


=head1 EXPORTS

=over

=item : 

$ERR $RESOLVED $CONNECTED $ACCEPTED $IN $OUT $EOF $SENT


=item : 

$EINBUFLIMIT


=back


=head1 INTERFACE

=over

=item B<new( \%PARAMS )>

  -.

 %PARAMS     ,     
   :

    :
  fh    host + port
  cb
    :
  wait_for
  method
  in_buf_limit
  out_buf
  out_pos

  ,       
. L</Public FIELDS>.

     [A-Z].    
     new()      .
      I/O 
   ,       new()
       callback (   
).

  write()   out_buf     
.

  .


=item B<write( $DATA )>

=item B<write()>

 , $DATA    .    fh
(. L</CLASSES>) $DATA     out_buf.  
 fh   write($DATA)  out_buf   undef ( 
  "previous packet isn't sent yet")  $DATA 
  out_buf.

  , write()    (  ,
, )     .  
   write()       out_buf,
      . :)    
   -  write()     
out_buf undef.

 write()        - 
out_buf  ,   -    ,  
write().        ,   
,          -
      write(),    .

   out_buf   ,     ,  
 write()    ()    
    .        out_buf
 out_pos       write().

  .


=item B<close()>

      ,    
        
.  fh (   close()).

  close()      -weaken
   (      ),
  POWER::Event::IO  .

   I/O   ,  -weaken   
    I/O  .    
 -weaken    ,      
close().

=over

   close()   X    callback,    
      X,  callback  X
    undef (..  -weaken    X
     ).

=back

  .


=item B<wait_for()>

wait_for()     .

   DoS       wait_for()
 $EOF   $IN  in_buf_limit.

   -  callback   
ݣ      ,     
wait_for().
      callback   
 ,     wait_for().

  .


=item B<io_wait>( TIMEOUT )

io_wait()     POWER::Event::loop().

Wait for one of:

 - some I/O events on FILEHANDLEs added by new()
 - TIMEOUT expires
 - signal arrives

Return: (STATUS, EVENTS), where:

 STATUS     if signal arrives     : undefined scalar
            if timeout expires    : 0
            if I/O events happens : positive number
 EVENTS     list with all I/O events in format suitable for
            POWER::Utils/run_callback()


=back


=head1 Public FIELDS

        
       .

       B<RO>   
  B<RW> ,   POWER::Event::IO  .

          
 _     (     
    )    [A-Z]
  (     new() /
//   ).


=over

=item B<fh>             I<RO>      new()

 filehandle    -.
        new(),
        
IP .      new()  
host  port.

=over

WARNING fh   .   -
  fh  .

=back


=item B<host>           I<RO>      new()

   fh    IP,  
fh   new()   host (    fh  host
 host  ). (   fh   
 socket()         
 IP.)

 host    IP  fh  
 :

   POWER::Event::IO  POWER::Event::IO::UDP_CONNECTED:
    connect($self->{fh},
        sockaddr_in($self->{port}, inet_aton($self->{ip})));
   POWER::Event::IO::LISTEN:
    setsockopt($self->{fh}, SOL_SOCKET, SO_REUSEADDR, pack('L!', 1));
    bind($self->{fh},
        sockaddr_in($self->{port}, inet_aton($self->{ip})));
    listen($self->{fh}, SOMAXCONN);

    wait_for $RESOLVED,    fh 
 callback.

=over

   POWER::Utils::IO    
 host : 'ANY', 'BROADCAST'  'LOOPBACK'  
   ..       
  fh.     , 
'ANY'   '0.0.0.0'  'LOOPBACK'  '127.0.0.1'.

=back


=item B<port>           I<RO>      new()

    fh (  fh  new()   host).


=item B<wait_for>       I<RO>    new()  wait_for()

 ,     callback.  :

  $ERR              -  ,       err
  $RESOLVED         - host , IP    ip
  $CONNECTED        -  ۣ
  $ACCEPTED         -   ,    in_buf,
                      paddr ݣ accept()-  paddr
  $IN               -       in_buf,
                      -     in_bytes
  $OUT              -  ()    out_buf,
                      -     out_bytes
  $EOF              -   EOF,   is_eof
  $SENT             - out_buf      

     ( 0).

 $ERR        wait_for.

  wait_for      $ACCEPTED|$IN|$EOF, 
  fh   .

    :

 $ERR
      ,     close().
            /
      ,     
       $ERR.
     WARNING     I/O   
      (     )
     __  callback  .   callback 
     write()        
     ,    write()    
       $ERR (,  - ).
 $RESOLVED
 $CONNECTED
       ;  ; etc.
 $ACCEPTED
         -  
          .
 $IN
      in_buf / in_bytes.   
         (     
     -)     in_buf  .
 $OUT
       ;  ; write().
 $EOF
       ; write(); close().
 $SENT
      shutdown(SHUT_WR)   EOF; write(); close().


=item B<cb>             I<RO>    new()

=item B<method>         I<RO>     new()

callback (  POWER::Utils::run_callback()),  
      wait_for.

  callback    -  -;
      events.

  callback .

  callback    
 (   $ERR   I/O).

=over

WARNING   callback   fork(),    
""  I/O  £     .

=back


=item B<in_buf_limit>   I<RW>     new()

   in_buf.  :

  undef             -   
  0                 -  
                      ( ,  DoS )
  >0                -   in_buf

  : undef.

  ,      wait_for
 $EOF    $IN -    in_buf_limit 
 ̣.

 in_buf     in_buf_limit 
 $ERR (err=$EINBUFLIMIT)   ɣ 
    in_buf    in_buf_limit.


=item B<out_buf>        I<RW>     new()

 .

   ,    :
  ( )    .
   ,    :
undef ( )   ( ..   ..  
 UDP-).

  out_buf    new(),  new() 
 write().


=item B<out_pos>        I<RW>     new()

   write()  out_buf.  :

  undef         - write()     out_buf,
                      out_buf
  >=0           - write()       out_buf,
                  out_pos   -  

  : undef.

    .


=item B<events>         I<RO>    callback

  , . wait_for.


=item B<err>            I<RO>    callback   $ERR

    (dualvar,  $!).
   $!.

     (..     $!)
   -1.   :

 resolving timed out
 connecting timed out
 writing timed out
 too long host name
 dns error: NXDOMAIN
 dns error: SRVERROR
 dns error: NODATA

 " in_buf_limit"       ,
    .     -100,   -1.
       $EINBUFLIMIT.
 :

 in_buf_limit reached


=item B<in_buf>         I<RW>

 .  : . out_buf.

  POWER::Event::IO::LISTEN    ݣ
 accept().


=item B<in_bytes>       I<RW>

ޣ  .
  : 0.

 ޣ        -
 .

       ,     
 .


=item B<in_paddr>       I<RW>

 paddr ݣ  accept()  
POWER::Event::IO::LISTEN.

 paddr ݣ  recv()   POWER::Event::IO::UDP.


=item B<out_bytes>      I<RW>

ޣ  .
. in_bytes.


=item B<out_paddr>      I<RW>

 paddr   send()   POWER::Event::IO::UDP.


=item B<ip>             I<RW>

 IP-    new()  fh   host.


=item B<is_eof>         I<RO>

 EOF:     EOF,    EOF.

   $EOF  ,  $EOF   callback 
 ,      wait_for,    
   EOF    .


=item B<fd>             I<RO>

  fileno(fh),      fileno().


=back


=head1 TIMEOUTS

       .

    .. "".  
  ( )  ""   
$POWER::Event::IO::TICK_RATE (. 1     ,  0.1
 10   ).  ,  , ,
  connect()  15   :

 # int  +0.5    ,   
 #    1 
 $POWER::Event::IO::TO_CONNECT
    = int 15 / $POWER::Event::IO::TICK_RATE + 0.5;

   ( TO_DNS_RESEND, ) 
 $ERR.  err     -1   
 .

=over

=item $POWER::Event::IO::TICK_RATE

.   .


=item $POWER::Event::IO::DNS::TO_DNS

   IP    new()  host  fh.

  30 .   : "resolving timed out".


=item $POWER::Event::IO::DNS::TO_DNS_RESEND

      DNS-    .

  2 .


=item $POWER::Event::IO::TO_CONNECT

   connect().    POWER::Event::IO
  host.

  30 .   : "connecting timed out".


=item $POWER::Event::IO::TO_WRITE

     ()   
.

  30 .   : "writing timed out".


=back


=head1 $SIG{PIPE}

  POWER::Event::IO     
$SIG{PIPE}  'IGNORE'    $SIG{PIPE}    .
.


=head1 SUPPORTED FILEHANDLE TYPES

.. POWER::Event::IO   epoll,   
"pollable" filehandles.   "pollable" fh    ,
   socket, pipe  fifo "pollable". ݣ  
    sysfs  "pollable".


=over

=item  

Not supported.

  I/O    (  -
    ).     .


=item  ,   Network FS

Not supported.

  I/O  100%,    
   -   , .


=item   . FS - procfs, devfs(udev), tmpfs, etc.

Partially supported.

   I/O   fs:
 tmpfs   ,   procfs  devfs  
   (     ).

   : /proc/version (), /dev/null (),
/dev/zero (), /dev/random (), /dev/urandom ().  
"pollable"  /dev/random.


=item TTY

Supported, but not recommended to use.

 I/O . Epoll  STDIN/STDOUT/STDERR   .


=item UNIX-

Supported.

      SOCK_STREAM ($STREAM).
 ,   SOCK_DGRAM unix-    
  SOCK_STREAM  SOCK_DGRAM.


=item INET- TCP (SOCK_STREAM)

Supported.

   ($STREAM)   ($LISTEN).


=item INET- UDP (SOCK_DGRAM)

Supported.

   ($UDP_CONNECTED)    ($UDP).


=item INET- RAW & other non-TCP/UDP; PACKET (non-IP) socket

??? Not tested yet.   .

   POWER::Event::IO   .
 I/O     sysread/syswrite,  
    $STREAM .


=item PIPE

Supported.

 I/O .


=item FIFO

Supported.

    I/O,   open.


=item Inotify

??? Not tested yet.   .


=item Directory

Not supported.

 I/O     .

     ,  fileno(DIRHANDLE)  undef,
   epoll    . :)


=back


=head1 REALIZATION

  I/O  epoll(2)   POWER::Epoll.

    callback    POWER::Event,
    I/O    -
, , etc.

     POWER::Event::Timer.

    nameserver   /etc/resolv.conf
 127.0.0.1.


=head1 DIAGNOSTICS

=head2 EXCEPTIONS

=over

=item C<< Oops. DNS resolver just died: %s" >>

 UDP- Σ  DNS-   $ERR.


=item C<< don't know what to do with resolved IP for UDP >>

  POWER::Event::IO::UDP->new() c host  fh.  
   host ..     
IP .


=item C<< Closed. Try again later, please... >>

  write()   out_buf  new()  POWER::Event::IO::LISTEN. :-)


=item C<< Usage: POWER::Event::IO->new({ OPTIONS }) >>

new()       -   .


=item C<< {cb} required >>

    new()   ̣ {cb}.


=item C<< socket: $! >>

    new()    {fh},   
  .


=item C<< {fh} or {host}+{port} required >>

    new()    {fh}     {host}  {port}.


=item C<< {fh} is not open FILEHANDLE >>

    new()    {fh}.


=item C<< you must do $io->close() first >>

 new()          
 fileno()       close().


=item C<< Usage: $io->wait_for( FLAGS ) >>

wait_for()    .


=item C<< wrong event mask >>

   wait_for()   {wait_for}  new() 
: undef         .


=item C<< you must set {in_buf_limit} if you wanna $EOF without $IN >>

   wait_for()   {wait_for}  new() $EOF  $IN,
     {in_buf_limit} undef.


=item C<< Usage: $io->write( [$buf] ) >>

write()        .


=item C<< previous packet isn't sent yet >>

  write()     ,     out_buf
 undef.


=item C<< usage: io_wait TIMEOUT >>

io_wait()     .


=item C<< wrong TIMEOUT $timeout >>

 io_wait()   undef   >= 0.


=item C<< Internal error: no I/O object for events=$events on fd=$fd >>

io_wait()   epoll_wait()     I/O.


=back


=head2 WARNINGS

None.


=head1 CONFIGURATION AND ENVIRONMENT

POWER::Event::IO uses only configuration file: /etc/resolv.conf.


=head1 DEPENDENCIES

 Perl6::Export::Attrs

 POWER::Epoll           2.0.0
 POWER::Event::Timer


=head1 INCOMPATIBILITIES

None reported.


=head1 BUGS AND LIMITATIONS

After fork() both parent and child will share POWER::Event::IO state, which
include epoll filehandle, DNS resolver socket, current timers, etc.
If two processes which share POWER::Event::IO state will try to continue
using POWER::Event and/or POWER::Event::IO the behaviour is undefined
(you probably got some strange events and/or 'Internal Error' exceptions).

Here is workaround in case you can't use POWER::Event::IO only in parent
process or only in single child process. You shouldn't load POWER::Event::IO
in parent process before all child which use POWER::Event::IO will be
fork()-ed:

 my $pid = fork();
 use vars qw( $ERR $RESOLVED $CONNECTED $ACCEPTED
              $IN $OUT $EOF $SENT $EINBUFLIMIT );
 eval '
 use POWER::Event;
 use POWER::Event::IO;
 ';


No bugs have been reported.

Please report any bugs or feature requests to C<powerman@asdfgroup.com>.


=head1 AUTHOR

Alex Efros  <powerman@asdfgroup.com>


=head1 LICENCE AND COPYRIGHT

Copyright (c) 2006, Alex Efros <powerman@asdfgroup.com>. All rights reserved.

This module is free software; you can redistribute it and/or
modify it under the same terms as Perl itself. See L<perlartistic>.


=head1 DISCLAIMER OF WARRANTY

BECAUSE THIS SOFTWARE IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE SOFTWARE, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE SOFTWARE "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE
ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOFTWARE IS WITH
YOU. SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL
NECESSARY SERVICING, REPAIR, OR CORRECTION.

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE SOFTWARE AS PERMITTED BY THE ABOVE LICENCE, BE
LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL,
OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
THE SOFTWARE (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
FAILURE OF THE SOFTWARE TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.
